# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.1.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class AkkaJSON(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ports': 'list[PortJSON]',
        'log_level': 'str',
        'remote_data_secret_matched': 'bool'
    }

    attribute_map = {
        'ports': 'ports',
        'log_level': 'log_level',
        'remote_data_secret_matched': 'remote_data_secret_matched'
    }

    def __init__(self, ports=None, log_level=None, remote_data_secret_matched=None, _configuration=None):  # noqa: E501
        """AkkaJSON - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._ports = None
        self._log_level = None
        self._remote_data_secret_matched = None
        self.discriminator = None

        self.ports = ports
        self.log_level = log_level
        if remote_data_secret_matched is not None:
            self.remote_data_secret_matched = remote_data_secret_matched

    @property
    def ports(self):
        """Gets the ports of this AkkaJSON.  # noqa: E501


        :return: The ports of this AkkaJSON.  # noqa: E501
        :rtype: list[PortJSON]
        """
        return self._ports

    @ports.setter
    def ports(self, ports):
        """Sets the ports of this AkkaJSON.


        :param ports: The ports of this AkkaJSON.  # noqa: E501
        :type: list[PortJSON]
        """
        if self._configuration.client_side_validation and ports is None:
            raise ValueError("Invalid value for `ports`, must not be `None`")  # noqa: E501

        self._ports = ports

    @property
    def log_level(self):
        """Gets the log_level of this AkkaJSON.  # noqa: E501


        :return: The log_level of this AkkaJSON.  # noqa: E501
        :rtype: str
        """
        return self._log_level

    @log_level.setter
    def log_level(self, log_level):
        """Sets the log_level of this AkkaJSON.


        :param log_level: The log_level of this AkkaJSON.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and log_level is None:
            raise ValueError("Invalid value for `log_level`, must not be `None`")  # noqa: E501

        self._log_level = log_level

    @property
    def remote_data_secret_matched(self):
        """Gets the remote_data_secret_matched of this AkkaJSON.  # noqa: E501


        :return: The remote_data_secret_matched of this AkkaJSON.  # noqa: E501
        :rtype: bool
        """
        return self._remote_data_secret_matched

    @remote_data_secret_matched.setter
    def remote_data_secret_matched(self, remote_data_secret_matched):
        """Sets the remote_data_secret_matched of this AkkaJSON.


        :param remote_data_secret_matched: The remote_data_secret_matched of this AkkaJSON.  # noqa: E501
        :type: bool
        """

        self._remote_data_secret_matched = remote_data_secret_matched

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AkkaJSON, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AkkaJSON):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AkkaJSON):
            return True

        return self.to_dict() != other.to_dict()
