# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.1.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class CheckbookOrdersJson(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account': 'AccountV310Json',
        'orders': 'list[OrderJson]'
    }

    attribute_map = {
        'account': 'account',
        'orders': 'orders'
    }

    def __init__(self, account=None, orders=None, _configuration=None):  # noqa: E501
        """CheckbookOrdersJson - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._account = None
        self._orders = None
        self.discriminator = None

        self.account = account
        self.orders = orders

    @property
    def account(self):
        """Gets the account of this CheckbookOrdersJson.  # noqa: E501


        :return: The account of this CheckbookOrdersJson.  # noqa: E501
        :rtype: AccountV310Json
        """
        return self._account

    @account.setter
    def account(self, account):
        """Sets the account of this CheckbookOrdersJson.


        :param account: The account of this CheckbookOrdersJson.  # noqa: E501
        :type: AccountV310Json
        """
        if self._configuration.client_side_validation and account is None:
            raise ValueError("Invalid value for `account`, must not be `None`")  # noqa: E501

        self._account = account

    @property
    def orders(self):
        """Gets the orders of this CheckbookOrdersJson.  # noqa: E501


        :return: The orders of this CheckbookOrdersJson.  # noqa: E501
        :rtype: list[OrderJson]
        """
        return self._orders

    @orders.setter
    def orders(self, orders):
        """Sets the orders of this CheckbookOrdersJson.


        :param orders: The orders of this CheckbookOrdersJson.  # noqa: E501
        :type: list[OrderJson]
        """
        if self._configuration.client_side_validation and orders is None:
            raise ValueError("Invalid value for `orders`, must not be `None`")  # noqa: E501

        self._orders = orders

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CheckbookOrdersJson, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CheckbookOrdersJson):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CheckbookOrdersJson):
            return True

        return self.to_dict() != other.to_dict()
