# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.1.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class CustomerMessageJson(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'from_person': 'str',
        'id': 'str',
        '_date': 'date',
        'from_department': 'str',
        'message': 'str'
    }

    attribute_map = {
        'from_person': 'from_person',
        'id': 'id',
        '_date': 'date',
        'from_department': 'from_department',
        'message': 'message'
    }

    def __init__(self, from_person=None, id=None, _date=None, from_department=None, message=None, _configuration=None):  # noqa: E501
        """CustomerMessageJson - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._from_person = None
        self._id = None
        self.__date = None
        self._from_department = None
        self._message = None
        self.discriminator = None

        self.from_person = from_person
        self.id = id
        self._date = _date
        self.from_department = from_department
        self.message = message

    @property
    def from_person(self):
        """Gets the from_person of this CustomerMessageJson.  # noqa: E501


        :return: The from_person of this CustomerMessageJson.  # noqa: E501
        :rtype: str
        """
        return self._from_person

    @from_person.setter
    def from_person(self, from_person):
        """Sets the from_person of this CustomerMessageJson.


        :param from_person: The from_person of this CustomerMessageJson.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and from_person is None:
            raise ValueError("Invalid value for `from_person`, must not be `None`")  # noqa: E501

        self._from_person = from_person

    @property
    def id(self):
        """Gets the id of this CustomerMessageJson.  # noqa: E501


        :return: The id of this CustomerMessageJson.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomerMessageJson.


        :param id: The id of this CustomerMessageJson.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def _date(self):
        """Gets the _date of this CustomerMessageJson.  # noqa: E501


        :return: The _date of this CustomerMessageJson.  # noqa: E501
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this CustomerMessageJson.


        :param _date: The _date of this CustomerMessageJson.  # noqa: E501
        :type: date
        """
        if self._configuration.client_side_validation and _date is None:
            raise ValueError("Invalid value for `_date`, must not be `None`")  # noqa: E501

        self.__date = _date

    @property
    def from_department(self):
        """Gets the from_department of this CustomerMessageJson.  # noqa: E501


        :return: The from_department of this CustomerMessageJson.  # noqa: E501
        :rtype: str
        """
        return self._from_department

    @from_department.setter
    def from_department(self, from_department):
        """Sets the from_department of this CustomerMessageJson.


        :param from_department: The from_department of this CustomerMessageJson.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and from_department is None:
            raise ValueError("Invalid value for `from_department`, must not be `None`")  # noqa: E501

        self._from_department = from_department

    @property
    def message(self):
        """Gets the message of this CustomerMessageJson.  # noqa: E501


        :return: The message of this CustomerMessageJson.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this CustomerMessageJson.


        :param message: The message of this CustomerMessageJson.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")  # noqa: E501

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomerMessageJson, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomerMessageJson):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CustomerMessageJson):
            return True

        return self.to_dict() != other.to_dict()
