# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.1.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class JsonConnectorMethod(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'connector_method_id': 'str',
        'method_name': 'str',
        'method_body': 'str',
        'programming_lang': 'str'
    }

    attribute_map = {
        'connector_method_id': 'connector_method_id',
        'method_name': 'method_name',
        'method_body': 'method_body',
        'programming_lang': 'programming_lang'
    }

    def __init__(self, connector_method_id=None, method_name=None, method_body=None, programming_lang=None, _configuration=None):  # noqa: E501
        """JsonConnectorMethod - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._connector_method_id = None
        self._method_name = None
        self._method_body = None
        self._programming_lang = None
        self.discriminator = None

        if connector_method_id is not None:
            self.connector_method_id = connector_method_id
        self.method_name = method_name
        self.method_body = method_body
        self.programming_lang = programming_lang

    @property
    def connector_method_id(self):
        """Gets the connector_method_id of this JsonConnectorMethod.  # noqa: E501


        :return: The connector_method_id of this JsonConnectorMethod.  # noqa: E501
        :rtype: str
        """
        return self._connector_method_id

    @connector_method_id.setter
    def connector_method_id(self, connector_method_id):
        """Sets the connector_method_id of this JsonConnectorMethod.


        :param connector_method_id: The connector_method_id of this JsonConnectorMethod.  # noqa: E501
        :type: str
        """

        self._connector_method_id = connector_method_id

    @property
    def method_name(self):
        """Gets the method_name of this JsonConnectorMethod.  # noqa: E501


        :return: The method_name of this JsonConnectorMethod.  # noqa: E501
        :rtype: str
        """
        return self._method_name

    @method_name.setter
    def method_name(self, method_name):
        """Sets the method_name of this JsonConnectorMethod.


        :param method_name: The method_name of this JsonConnectorMethod.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and method_name is None:
            raise ValueError("Invalid value for `method_name`, must not be `None`")  # noqa: E501

        self._method_name = method_name

    @property
    def method_body(self):
        """Gets the method_body of this JsonConnectorMethod.  # noqa: E501


        :return: The method_body of this JsonConnectorMethod.  # noqa: E501
        :rtype: str
        """
        return self._method_body

    @method_body.setter
    def method_body(self, method_body):
        """Sets the method_body of this JsonConnectorMethod.


        :param method_body: The method_body of this JsonConnectorMethod.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and method_body is None:
            raise ValueError("Invalid value for `method_body`, must not be `None`")  # noqa: E501

        self._method_body = method_body

    @property
    def programming_lang(self):
        """Gets the programming_lang of this JsonConnectorMethod.  # noqa: E501


        :return: The programming_lang of this JsonConnectorMethod.  # noqa: E501
        :rtype: str
        """
        return self._programming_lang

    @programming_lang.setter
    def programming_lang(self, programming_lang):
        """Sets the programming_lang of this JsonConnectorMethod.


        :param programming_lang: The programming_lang of this JsonConnectorMethod.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and programming_lang is None:
            raise ValueError("Invalid value for `programming_lang`, must not be `None`")  # noqa: E501

        self._programming_lang = programming_lang

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(JsonConnectorMethod, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JsonConnectorMethod):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, JsonConnectorMethod):
            return True

        return self.to_dict() != other.to_dict()
