# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.1.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class ResourceDocsJson(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'resource_docs': 'list[ResourceDocJson]',
        'meta': 'ResourceDocMeta'
    }

    attribute_map = {
        'resource_docs': 'resource_docs',
        'meta': 'meta'
    }

    def __init__(self, resource_docs=None, meta=None, _configuration=None):  # noqa: E501
        """ResourceDocsJson - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._resource_docs = None
        self._meta = None
        self.discriminator = None

        self.resource_docs = resource_docs
        if meta is not None:
            self.meta = meta

    @property
    def resource_docs(self):
        """Gets the resource_docs of this ResourceDocsJson.  # noqa: E501


        :return: The resource_docs of this ResourceDocsJson.  # noqa: E501
        :rtype: list[ResourceDocJson]
        """
        return self._resource_docs

    @resource_docs.setter
    def resource_docs(self, resource_docs):
        """Sets the resource_docs of this ResourceDocsJson.


        :param resource_docs: The resource_docs of this ResourceDocsJson.  # noqa: E501
        :type: list[ResourceDocJson]
        """
        if self._configuration.client_side_validation and resource_docs is None:
            raise ValueError("Invalid value for `resource_docs`, must not be `None`")  # noqa: E501

        self._resource_docs = resource_docs

    @property
    def meta(self):
        """Gets the meta of this ResourceDocsJson.  # noqa: E501


        :return: The meta of this ResourceDocsJson.  # noqa: E501
        :rtype: ResourceDocMeta
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this ResourceDocsJson.


        :param meta: The meta of this ResourceDocsJson.  # noqa: E501
        :type: ResourceDocMeta
        """

        self._meta = meta

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceDocsJson, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceDocsJson):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ResourceDocsJson):
            return True

        return self.to_dict() != other.to_dict()
