# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.1.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class UpdateAccountRequestJsonV310(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'label': 'str',
        'type': 'str',
        'branch_id': 'str',
        'account_routings': 'list[AccountRoutingJsonV121]'
    }

    attribute_map = {
        'label': 'label',
        'type': 'type',
        'branch_id': 'branch_id',
        'account_routings': 'account_routings'
    }

    def __init__(self, label=None, type=None, branch_id=None, account_routings=None, _configuration=None):  # noqa: E501
        """UpdateAccountRequestJsonV310 - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._label = None
        self._type = None
        self._branch_id = None
        self._account_routings = None
        self.discriminator = None

        self.label = label
        self.type = type
        self.branch_id = branch_id
        self.account_routings = account_routings

    @property
    def label(self):
        """Gets the label of this UpdateAccountRequestJsonV310.  # noqa: E501


        :return: The label of this UpdateAccountRequestJsonV310.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this UpdateAccountRequestJsonV310.


        :param label: The label of this UpdateAccountRequestJsonV310.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and label is None:
            raise ValueError("Invalid value for `label`, must not be `None`")  # noqa: E501

        self._label = label

    @property
    def type(self):
        """Gets the type of this UpdateAccountRequestJsonV310.  # noqa: E501


        :return: The type of this UpdateAccountRequestJsonV310.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this UpdateAccountRequestJsonV310.


        :param type: The type of this UpdateAccountRequestJsonV310.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def branch_id(self):
        """Gets the branch_id of this UpdateAccountRequestJsonV310.  # noqa: E501


        :return: The branch_id of this UpdateAccountRequestJsonV310.  # noqa: E501
        :rtype: str
        """
        return self._branch_id

    @branch_id.setter
    def branch_id(self, branch_id):
        """Sets the branch_id of this UpdateAccountRequestJsonV310.


        :param branch_id: The branch_id of this UpdateAccountRequestJsonV310.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and branch_id is None:
            raise ValueError("Invalid value for `branch_id`, must not be `None`")  # noqa: E501

        self._branch_id = branch_id

    @property
    def account_routings(self):
        """Gets the account_routings of this UpdateAccountRequestJsonV310.  # noqa: E501


        :return: The account_routings of this UpdateAccountRequestJsonV310.  # noqa: E501
        :rtype: list[AccountRoutingJsonV121]
        """
        return self._account_routings

    @account_routings.setter
    def account_routings(self, account_routings):
        """Sets the account_routings of this UpdateAccountRequestJsonV310.


        :param account_routings: The account_routings of this UpdateAccountRequestJsonV310.  # noqa: E501
        :type: list[AccountRoutingJsonV121]
        """
        if self._configuration.client_side_validation and account_routings is None:
            raise ValueError("Invalid value for `account_routings`, must not be `None`")  # noqa: E501

        self._account_routings = account_routings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateAccountRequestJsonV310, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateAccountRequestJsonV310):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateAccountRequestJsonV310):
            return True

        return self.to_dict() != other.to_dict()
